"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var assign = require("object-assign");
function updateFieldInFieldTree(field, fields) {
    var items = fields.filter(function (f) { return f.id === field.id; });
    var index = -1;
    if (items.length > 1) {
        throw new Error('impossible');
    }
    else if (items.length == 1) {
        index = fields.indexOf(items[0]);
    }
    else {
        for (var i = 0; i < fields.length; i++) {
            if (fields[i].fields) {
                var nestedFields = updateFieldInFieldTree(field, fields[i].fields);
                if (nestedFields) {
                    index = i;
                    field = assign({}, fields[i], {
                        fields: nestedFields
                    });
                    break;
                }
            }
        }
    }
    if (index >= 0) {
        var newFields = fields.slice();
        newFields[index] = field;
        return newFields;
    }
    return null;
}
exports.updateFieldInFieldTree = updateFieldInFieldTree;
function getFieldSiblings(field, fields) {
    var index = fields.indexOf(field);
    if (index >= 0) {
        return fields;
    }
    for (var _i = 0, fields_1 = fields; _i < fields_1.length; _i++) {
        var f = fields_1[_i];
        if (f.fields) {
            var siblings = getFieldSiblings(field, f.fields);
            if (siblings) {
                return siblings;
            }
        }
    }
    return null;
}
exports.getFieldSiblings = getFieldSiblings;
